import * as React from 'react';
import * as PropTypes from 'prop-types';
export declare const ArtboardPropTypes: {
    style: PropTypes.Requireable<number | PropTypes.InferProps<{
        display: PropTypes.Requireable<string>;
        color: PropTypes.Requireable<string | number>;
        shadowColor: PropTypes.Requireable<string | number>;
        shadowInner: PropTypes.Requireable<boolean>;
        shadowSpread: PropTypes.Requireable<number>;
        shadowOffset: PropTypes.Requireable<PropTypes.InferProps<{
            width: PropTypes.Requireable<number>;
            height: PropTypes.Requireable<number>;
        }>>;
        shadowOpacity: PropTypes.Requireable<number>;
        shadowRadius: PropTypes.Requireable<number>;
        width: PropTypes.Requireable<number>;
        height: PropTypes.Requireable<number>;
        top: PropTypes.Requireable<number>;
        left: PropTypes.Requireable<number>;
        right: PropTypes.Requireable<number>;
        bottom: PropTypes.Requireable<number>;
        minWidth: PropTypes.Requireable<number>;
        maxWidth: PropTypes.Requireable<number>;
        minHeight: PropTypes.Requireable<number>;
        maxHeight: PropTypes.Requireable<number>;
        margin: PropTypes.Requireable<number>;
        marginVertical: PropTypes.Requireable<number>;
        marginHorizontal: PropTypes.Requireable<number>;
        marginTop: PropTypes.Requireable<number>;
        marginBottom: PropTypes.Requireable<number>;
        marginLeft: PropTypes.Requireable<number>;
        marginRight: PropTypes.Requireable<number>;
        padding: PropTypes.Requireable<number>;
        paddingVertical: PropTypes.Requireable<number>;
        paddingHorizontal: PropTypes.Requireable<number>;
        paddingTop: PropTypes.Requireable<number>;
        paddingBottom: PropTypes.Requireable<number>;
        paddingLeft: PropTypes.Requireable<number>;
        paddingRight: PropTypes.Requireable<number>;
        position: PropTypes.Requireable<"absolute" | "relative">;
        flexDirection: PropTypes.Requireable<"column" | "column-reverse" | "row" | "row-reverse">;
        flexWrap: PropTypes.Requireable<"nowrap" | "wrap" | "wrap-reverse">;
        justifyContent: PropTypes.Requireable<"center" | "space-around" | "space-between" | "flex-end" | "flex-start">;
        alignContent: PropTypes.Requireable<"auto" | "center" | "space-around" | "space-between" | "stretch" | "flex-end" | "flex-start" | "baseline">;
        alignItems: PropTypes.Requireable<"center" | "stretch" | "flex-end" | "flex-start" | "baseline">;
        alignSelf: PropTypes.Requireable<"auto" | "center" | "stretch" | "flex-end" | "flex-start" | "baseline">;
        overflow: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
        overflowX: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
        overflowY: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
        flex: PropTypes.Requireable<number>;
        flexGrow: PropTypes.Requireable<number>;
        flexShrink: PropTypes.Requireable<number>;
        flexBasis: PropTypes.Requireable<number>;
        aspectRatio: PropTypes.Requireable<number>;
        zIndex: PropTypes.Requireable<number>;
        backfaceVisibility: PropTypes.Requireable<VisibilityState>;
        backgroundColor: PropTypes.Requireable<string | number>;
        borderColor: PropTypes.Requireable<string | number>;
        borderTopColor: PropTypes.Requireable<string | number>;
        borderRightColor: PropTypes.Requireable<string | number>;
        borderBottomColor: PropTypes.Requireable<string | number>;
        borderLeftColor: PropTypes.Requireable<string | number>;
        borderRadius: PropTypes.Requireable<number>;
        borderTopLeftRadius: PropTypes.Requireable<number>;
        borderTopRightRadius: PropTypes.Requireable<number>;
        borderBottomLeftRadius: PropTypes.Requireable<number>;
        borderBottomRightRadius: PropTypes.Requireable<number>;
        borderStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
        borderTopStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
        borderRightStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
        borderBottomStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
        borderLeftStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
        borderWidth: PropTypes.Requireable<number>;
        borderTopWidth: PropTypes.Requireable<number>;
        borderRightWidth: PropTypes.Requireable<number>;
        borderBottomWidth: PropTypes.Requireable<number>;
        borderLeftWidth: PropTypes.Requireable<number>;
        opacity: PropTypes.Requireable<number>;
        transform: PropTypes.Requireable<string>;
        transformOrigin: PropTypes.Requireable<string>;
    }> | null | undefined>;
    id: PropTypes.Requireable<string>;
    name: PropTypes.Requireable<string>;
    isHome: PropTypes.Requireable<boolean>;
    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    viewport: PropTypes.Requireable<PropTypes.InferProps<{
        name: PropTypes.Requireable<string>;
        width: PropTypes.Requireable<number>;
        height: PropTypes.Requireable<number>;
        scale: PropTypes.Requireable<number>;
        fontScale: PropTypes.Requireable<number>;
    }>>;
};
export declare type Props = PropTypes.InferProps<typeof ArtboardPropTypes>;
export declare class Artboard extends React.Component<Props> {
    static propTypes: {
        style: PropTypes.Requireable<number | PropTypes.InferProps<{
            display: PropTypes.Requireable<string>;
            color: PropTypes.Requireable<string | number>;
            shadowColor: PropTypes.Requireable<string | number>;
            shadowInner: PropTypes.Requireable<boolean>;
            shadowSpread: PropTypes.Requireable<number>;
            shadowOffset: PropTypes.Requireable<PropTypes.InferProps<{
                width: PropTypes.Requireable<number>;
                height: PropTypes.Requireable<number>;
            }>>;
            shadowOpacity: PropTypes.Requireable<number>;
            shadowRadius: PropTypes.Requireable<number>;
            width: PropTypes.Requireable<number>;
            height: PropTypes.Requireable<number>;
            top: PropTypes.Requireable<number>;
            left: PropTypes.Requireable<number>;
            right: PropTypes.Requireable<number>;
            bottom: PropTypes.Requireable<number>;
            minWidth: PropTypes.Requireable<number>;
            maxWidth: PropTypes.Requireable<number>;
            minHeight: PropTypes.Requireable<number>;
            maxHeight: PropTypes.Requireable<number>;
            margin: PropTypes.Requireable<number>;
            marginVertical: PropTypes.Requireable<number>;
            marginHorizontal: PropTypes.Requireable<number>;
            marginTop: PropTypes.Requireable<number>;
            marginBottom: PropTypes.Requireable<number>;
            marginLeft: PropTypes.Requireable<number>;
            marginRight: PropTypes.Requireable<number>;
            padding: PropTypes.Requireable<number>;
            paddingVertical: PropTypes.Requireable<number>;
            paddingHorizontal: PropTypes.Requireable<number>;
            paddingTop: PropTypes.Requireable<number>;
            paddingBottom: PropTypes.Requireable<number>;
            paddingLeft: PropTypes.Requireable<number>;
            paddingRight: PropTypes.Requireable<number>;
            position: PropTypes.Requireable<"absolute" | "relative">;
            flexDirection: PropTypes.Requireable<"column" | "column-reverse" | "row" | "row-reverse">;
            flexWrap: PropTypes.Requireable<"nowrap" | "wrap" | "wrap-reverse">;
            justifyContent: PropTypes.Requireable<"center" | "space-around" | "space-between" | "flex-end" | "flex-start">;
            alignContent: PropTypes.Requireable<"auto" | "center" | "space-around" | "space-between" | "stretch" | "flex-end" | "flex-start" | "baseline">;
            alignItems: PropTypes.Requireable<"center" | "stretch" | "flex-end" | "flex-start" | "baseline">;
            alignSelf: PropTypes.Requireable<"auto" | "center" | "stretch" | "flex-end" | "flex-start" | "baseline">;
            overflow: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
            overflowX: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
            overflowY: PropTypes.Requireable<"hidden" | "visible" | "scroll">;
            flex: PropTypes.Requireable<number>;
            flexGrow: PropTypes.Requireable<number>;
            flexShrink: PropTypes.Requireable<number>;
            flexBasis: PropTypes.Requireable<number>;
            aspectRatio: PropTypes.Requireable<number>;
            zIndex: PropTypes.Requireable<number>;
            backfaceVisibility: PropTypes.Requireable<VisibilityState>;
            backgroundColor: PropTypes.Requireable<string | number>;
            borderColor: PropTypes.Requireable<string | number>;
            borderTopColor: PropTypes.Requireable<string | number>;
            borderRightColor: PropTypes.Requireable<string | number>;
            borderBottomColor: PropTypes.Requireable<string | number>;
            borderLeftColor: PropTypes.Requireable<string | number>;
            borderRadius: PropTypes.Requireable<number>;
            borderTopLeftRadius: PropTypes.Requireable<number>;
            borderTopRightRadius: PropTypes.Requireable<number>;
            borderBottomLeftRadius: PropTypes.Requireable<number>;
            borderBottomRightRadius: PropTypes.Requireable<number>;
            borderStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
            borderTopStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
            borderRightStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
            borderBottomStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
            borderLeftStyle: PropTypes.Requireable<"dashed" | "dotted" | "solid">;
            borderWidth: PropTypes.Requireable<number>;
            borderTopWidth: PropTypes.Requireable<number>;
            borderRightWidth: PropTypes.Requireable<number>;
            borderBottomWidth: PropTypes.Requireable<number>;
            borderLeftWidth: PropTypes.Requireable<number>;
            opacity: PropTypes.Requireable<number>;
            transform: PropTypes.Requireable<string>;
            transformOrigin: PropTypes.Requireable<string>;
        }> | null | undefined>;
        id: PropTypes.Requireable<string>;
        name: PropTypes.Requireable<string>;
        isHome: PropTypes.Requireable<boolean>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        viewport: PropTypes.Requireable<PropTypes.InferProps<{
            name: PropTypes.Requireable<string>;
            width: PropTypes.Requireable<number>;
            height: PropTypes.Requireable<number>;
            scale: PropTypes.Requireable<number>;
            fontScale: PropTypes.Requireable<number>;
        }>>;
    };
    static defaultProps: {
        name: string;
    };
    render(): JSX.Element;
}
