"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Image = exports.ImagePropTypes = exports.ImageSourcePropType = void 0;
const React = __importStar(require("react"));
const PropTypes = __importStar(require("prop-types"));
const airbnb_prop_types_1 = require("airbnb-prop-types");
const stylesheet_1 = require("../stylesheet");
const ResizeModePropTypes_1 = require("./ResizeModePropTypes");
const ImageStylePropTypes_1 = require("./ImageStylePropTypes");
const View_1 = require("./View");
const ImageURISourcePropType = PropTypes.shape({
    uri: PropTypes.string.isRequired,
    height: PropTypes.number,
    width: PropTypes.number,
});
exports.ImageSourcePropType = PropTypes.oneOfType([
    ImageURISourcePropType,
    // PropTypes.arrayOf(ImageURISourcePropType), // TODO: handle me
    PropTypes.string,
]);
const ResizeModes = {
    contain: 3,
    cover: 1,
    stretch: 2,
    center: 1,
    repeat: 0,
    none: 1,
};
exports.ImagePropTypes = Object.assign(Object.assign({}, View_1.ViewPropTypes), { style: airbnb_prop_types_1.or([PropTypes.shape(ImageStylePropTypes_1.ImageStylePropTypes), PropTypes.number]), defaultSource: exports.ImageSourcePropType, resizeMode: ResizeModePropTypes_1.ResizeModePropTypes, source: exports.ImageSourcePropType });
class Image extends React.Component {
    render() {
        const { children, source, defaultSource, resizeMode, name, resizingConstraint } = this.props;
        let style = stylesheet_1.StyleSheet.flatten(this.props.style) || {};
        const sketchResizeMode = ResizeModes[resizeMode || (style && style.resizeMode) || 'cover'];
        if (source && typeof source !== 'string') {
            style = Object.assign({ height: source.height, width: source.width }, style);
        }
        return (React.createElement("sketch_image", { style: style, source: source || defaultSource, name: name, resizeMode: sketchResizeMode, resizingConstraint: resizingConstraint }, children));
    }
}
exports.Image = Image;
Image.propTypes = exports.ImagePropTypes;
Image.defaultProps = {
    name: 'Image',
};
