"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Svg = void 0;
const React = __importStar(require("react"));
const PropTypes = __importStar(require("prop-types"));
const View_1 = require("../View");
const stylesheet_1 = require("../../stylesheet");
const Circle_1 = require("./Circle");
const ClipPath_1 = require("./ClipPath");
const Defs_1 = require("./Defs");
const Ellipse_1 = require("./Ellipse");
const G_1 = require("./G");
const Image_1 = require("./Image");
const Line_1 = require("./Line");
const LinearGradient_1 = require("./LinearGradient");
const Path_1 = require("./Path");
const Pattern_1 = require("./Pattern");
const Polygon_1 = require("./Polygon");
const Polyline_1 = require("./Polyline");
const RadialGradient_1 = require("./RadialGradient");
const Rect_1 = require("./Rect");
const Stop_1 = require("./Stop");
const Symbol_1 = require("./Symbol");
const Text_1 = require("./Text");
const TextPath_1 = require("./TextPath");
const TSpan_1 = require("./TSpan");
const Use_1 = require("./Use");
const propTypes = Object.assign(Object.assign({}, View_1.ViewPropTypes), { opacity: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), 
    // more detail https://svgwg.org/svg2-draft/coords.html#ViewBoxAttribute
    viewBox: PropTypes.string, preserveAspectRatio: PropTypes.string, xmlns: PropTypes.string, 'xmlns:xlink': PropTypes.string });
class Svg extends React.Component {
    render() {
        const _a = this.props, { children, style } = _a, rest = __rest(_a, ["children", "style"]);
        return (React.createElement("sketch_svg", Object.assign({}, rest, { style: stylesheet_1.StyleSheet.flatten(style) }), children));
    }
}
exports.Svg = Svg;
Svg.displayName = 'Svg';
Svg.propTypes = propTypes;
Svg.defaultProps = {
    preserveAspectRatio: 'xMidYMid meet',
};
Svg.Circle = Circle_1.Circle;
Svg.ClipPath = ClipPath_1.ClipPath;
Svg.Defs = Defs_1.Defs;
Svg.Ellipse = Ellipse_1.Ellipse;
Svg.G = G_1.G;
Svg.Image = Image_1.SVGImage;
Svg.Line = Line_1.Line;
Svg.LinearGradient = LinearGradient_1.LinearGradient;
Svg.Path = Path_1.Path;
Svg.Pattern = Pattern_1.Pattern;
Svg.Polygon = Polygon_1.Polygon;
Svg.Polyline = Polyline_1.Polyline;
Svg.RadialGradient = RadialGradient_1.RadialGradient;
Svg.Rect = Rect_1.Rect;
Svg.Stop = Stop_1.Stop;
Svg.Symbol = Symbol_1.Symbol;
Svg.Text = Text_1.Text;
Svg.TextPath = TextPath_1.TextPath;
Svg.TSpan = TSpan_1.TSpan;
Svg.Use = Use_1.Use;
