"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArtboardProvider = exports.useWindowDimensions = exports.ArtboardContext = void 0;
const React = __importStar(require("react"));
const PropTypes = __importStar(require("prop-types"));
const initialArtboardState = {
    width: 0,
    height: 0,
    scale: 1,
    fontScale: 1,
};
exports.ArtboardContext = React.createContext({
    state: initialArtboardState,
});
exports.useWindowDimensions = () => {
    const { state } = React.useContext(exports.ArtboardContext);
    const { width, height, scale, fontScale } = state || {};
    return { width, height, scale, fontScale };
};
const ArtboardPropTypes = {
    viewport: PropTypes.shape({
        width: PropTypes.number,
        height: PropTypes.number,
        name: PropTypes.string,
        scale: PropTypes.number,
        fontScale: PropTypes.number,
    }),
    children: PropTypes.node,
};
exports.ArtboardProvider = ({ children, viewport, style }) => {
    if (!viewport) {
        return children;
    }
    const { state: oState } = React.useContext(exports.ArtboardContext);
    const state = Object.assign(Object.assign({}, oState), { width: viewport.width || (style || {}).width || oState.width, height: viewport.height || (style || {}).height || oState.height, scale: viewport.scale || oState.scale, fontScale: viewport.fontScale || oState.scale });
    return React.createElement(exports.ArtboardContext.Provider, { value: { state } }, children);
};
