"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextStyles = exports.makeSymbol = exports.renderToJSON = exports.render = void 0;
const render_1 = require("./render");
const renderToJSON_1 = require("./renderToJSON");
const symbol_1 = require("./symbol");
const TextStyles_1 = require("./sharedStyles/TextStyles");
function getDefaultPlatformBridge() {
    return require('./platformBridges/macos').default;
}
function render(element, container, platformBridge = getDefaultPlatformBridge()) {
    return render_1.render(platformBridge)(element, container);
}
exports.render = render;
function renderToJSON(element, platformBridge = getDefaultPlatformBridge()) {
    return renderToJSON_1.renderToJSON(platformBridge)(element);
}
exports.renderToJSON = renderToJSON;
function makeSymbol(Component, symbolProps, document, bridge = getDefaultPlatformBridge()) {
    return symbol_1.makeSymbol(bridge)(Component, symbolProps, document);
}
exports.makeSymbol = makeSymbol;
exports.TextStyles = TextStyles_1.TextStyles(() => getDefaultPlatformBridge());
