"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hotspotLayer = void 0;
const models_1 = require("./models");
const animationTypes = {
    none: -1,
    slideFromRight: 0,
    slideFromLeft: 1,
    slideFromBottom: 2,
    slideFromTop: 3,
};
const BackTarget = 'back';
const getArtboard = (target) => {
    if (target === BackTarget) {
        return BackTarget;
    }
    return models_1.generateID(`artboard:${target}`, true);
};
exports.hotspotLayer = ({ targetId, target, animationType, }) => ({
    flow: {
        _class: 'MSImmutableFlowConnection',
        animationType: (animationType && animationTypes[animationType]) || -1,
        destinationArtboardID: target ? getArtboard(target) : targetId || 'broken',
    },
});
