var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import { or } from 'airbnb-prop-types';
import { StyleSheet } from '../stylesheet';
import { ResizeModePropTypes } from './ResizeModePropTypes';
import { ImageStylePropTypes } from './ImageStylePropTypes';
import { ViewPropTypes } from './View';
var ImageURISourcePropType = PropTypes.shape({
    uri: PropTypes.string.isRequired,
    height: PropTypes.number,
    width: PropTypes.number,
});
export var ImageSourcePropType = PropTypes.oneOfType([
    ImageURISourcePropType,
    // PropTypes.arrayOf(ImageURISourcePropType), // TODO: handle me
    PropTypes.string,
]);
var ResizeModes = {
    contain: 3,
    cover: 1,
    stretch: 2,
    center: 1,
    repeat: 0,
    none: 1,
};
export var ImagePropTypes = __assign(__assign({}, ViewPropTypes), { style: or([PropTypes.shape(ImageStylePropTypes), PropTypes.number]), defaultSource: ImageSourcePropType, resizeMode: ResizeModePropTypes, source: ImageSourcePropType });
var Image = /** @class */ (function (_super) {
    __extends(Image, _super);
    function Image() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Image.prototype.render = function () {
        var _a = this.props, children = _a.children, source = _a.source, defaultSource = _a.defaultSource, resizeMode = _a.resizeMode, name = _a.name, resizingConstraint = _a.resizingConstraint;
        var style = StyleSheet.flatten(this.props.style) || {};
        var sketchResizeMode = ResizeModes[resizeMode || (style && style.resizeMode) || 'cover'];
        if (source && typeof source !== 'string') {
            style = __assign({ height: source.height, width: source.width }, style);
        }
        return (React.createElement("sketch_image", { style: style, source: source || defaultSource, name: name, resizeMode: sketchResizeMode, resizingConstraint: resizingConstraint }, children));
    };
    Image.propTypes = ImagePropTypes;
    Image.defaultProps = {
        name: 'Image',
    };
    return Image;
}(React.Component));
export { Image };
