var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import * as PropTypes from 'prop-types';
import ErrorStackParser from 'error-stack-parser';
import { Text } from './Text';
import { View } from './View';
var styles = {
    redbox: {
        padding: 10,
        width: 480,
        backgroundColor: 'rgb(204, 0, 0)',
    },
    frame: {},
    message: {
        fontWeight: 'bold',
        fontSize: 16,
        lineHeight: 16 * 1.2,
        color: 'white',
    },
    stack: {
        fontFamily: 'Monaco',
        marginTop: 20,
        color: 'white',
    },
};
export var ErrorBoxPropTypes = {
    error: PropTypes.oneOfType([PropTypes.instanceOf(Error), PropTypes.string]).isRequired,
};
var RedBox = /** @class */ (function (_super) {
    __extends(RedBox, _super);
    function RedBox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RedBox.prototype.renderFrames = function (frames) {
        return frames.map(function (f, index) { return (React.createElement(Text, { key: index, style: styles.stack }, f.functionName)); });
    };
    RedBox.prototype.render = function () {
        var error = this.props.error;
        if (typeof error === 'string') {
            return (React.createElement(View, { name: "RedBox", style: styles.redbox },
                React.createElement(Text, { name: "Message", style: styles.message }, "Error: " + error)));
        }
        var frames;
        var parseError;
        var frameChildren;
        try {
            frames = ErrorStackParser.parse(error);
        }
        catch (e) {
            parseError = new Error('Failed to parse stack trace. Stack trace information unavailable.');
        }
        if (parseError) {
            frameChildren = (React.createElement(View, { style: styles.frame, key: 0 },
                React.createElement(View, null, parseError.message)));
        }
        if (frames) {
            frameChildren = this.renderFrames(frames);
        }
        return (React.createElement(View, { name: "RedBox", style: styles.redbox },
            React.createElement(Text, { name: "Message", style: styles.message }, error.name + ": " + error.message),
            React.createElement(View, { name: "Frames", style: styles.stack }, frameChildren)));
    };
    RedBox.propTypes = ErrorBoxPropTypes;
    RedBox.defaultProps = {
        useLines: true,
        useColumns: true,
    };
    return RedBox;
}(React.Component));
export { RedBox };
