var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import { ViewPropTypes } from '../View';
import { StyleSheet } from '../../stylesheet';
import { Circle } from './Circle';
import { ClipPath } from './ClipPath';
import { Defs } from './Defs';
import { Ellipse } from './Ellipse';
import { G } from './G';
import { SVGImage as Image } from './Image';
import { Line } from './Line';
import { LinearGradient } from './LinearGradient';
import { Path } from './Path';
import { Pattern } from './Pattern';
import { Polygon } from './Polygon';
import { Polyline } from './Polyline';
import { RadialGradient } from './RadialGradient';
import { Rect } from './Rect';
import { Stop } from './Stop';
import { Symbol } from './Symbol';
import { Text } from './Text';
import { TextPath } from './TextPath';
import { TSpan } from './TSpan';
import { Use } from './Use';
var propTypes = __assign(__assign({}, ViewPropTypes), { opacity: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]), 
    // more detail https://svgwg.org/svg2-draft/coords.html#ViewBoxAttribute
    viewBox: PropTypes.string, preserveAspectRatio: PropTypes.string, xmlns: PropTypes.string, 'xmlns:xlink': PropTypes.string });
var Svg = /** @class */ (function (_super) {
    __extends(Svg, _super);
    function Svg() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Svg.prototype.render = function () {
        var _a = this.props, children = _a.children, style = _a.style, rest = __rest(_a, ["children", "style"]);
        return (React.createElement("sketch_svg", __assign({}, rest, { style: StyleSheet.flatten(style) }), children));
    };
    Svg.displayName = 'Svg';
    Svg.propTypes = propTypes;
    Svg.defaultProps = {
        preserveAspectRatio: 'xMidYMid meet',
    };
    Svg.Circle = Circle;
    Svg.ClipPath = ClipPath;
    Svg.Defs = Defs;
    Svg.Ellipse = Ellipse;
    Svg.G = G;
    Svg.Image = Image;
    Svg.Line = Line;
    Svg.LinearGradient = LinearGradient;
    Svg.Path = Path;
    Svg.Pattern = Pattern;
    Svg.Polygon = Polygon;
    Svg.Polyline = Polyline;
    Svg.RadialGradient = RadialGradient;
    Svg.Rect = Rect;
    Svg.Stop = Stop;
    Svg.Symbol = Symbol;
    Svg.Text = Text;
    Svg.TextPath = TextPath;
    Svg.TSpan = TSpan;
    Svg.Use = Use;
    return Svg;
}(React.Component));
export { Svg };
