import * as React from 'react';
import * as PropTypes from 'prop-types';
import { Style } from './stylesheet/types';
export declare const ArtboardContext: React.Context<{
    state: {
        width: number;
        height: number;
        scale: number;
        fontScale: number;
    };
}>;
export declare const useWindowDimensions: () => {
    width: number;
    height: number;
    scale: number;
    fontScale: number;
};
declare const ArtboardPropTypes: {
    viewport: PropTypes.Requireable<PropTypes.InferProps<{
        width: PropTypes.Requireable<number>;
        height: PropTypes.Requireable<number>;
        name: PropTypes.Requireable<string>;
        scale: PropTypes.Requireable<number>;
        fontScale: PropTypes.Requireable<number>;
    }>>;
    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
};
declare type ArtboardProps = PropTypes.InferProps<typeof ArtboardPropTypes> & {
    children: any;
    style?: Style;
};
export declare const ArtboardProvider: ({ children, viewport, style }: ArtboardProps) => any;
export {};
