import { render as _render } from './render';
import { renderToJSON as _renderToJSON } from './renderToJSON';
import { makeSymbol as _makeSymbol } from './symbol';
import { TextStyles as _TextStyles } from './sharedStyles/TextStyles';
import SketchBridge from './platformBridges/sketch';
export function render(element, container, platformBridge) {
    if (platformBridge === void 0) { platformBridge = SketchBridge; }
    return _render(platformBridge)(element, container);
}
export function renderToJSON(element, platformBridge) {
    if (platformBridge === void 0) { platformBridge = SketchBridge; }
    return _renderToJSON(platformBridge)(element);
}
export function makeSymbol(Component, symbolProps, document, bridge) {
    if (bridge === void 0) { bridge = SketchBridge; }
    return _makeSymbol(bridge)(Component, symbolProps, document);
}
export var TextStyles = _TextStyles(function () { return SketchBridge; });
