var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { FileFormat1 as FileFormat } from '@sketch-hq/sketch-file-format-ts';
import { makeResizeConstraint } from './resizeConstraint';
import { generateID, makeRect, makeColorFromCSS, emptyGradient } from './models';
import { makeStyle } from './style';
export var makeHorizontalPath = function () { return ({
    isClosed: false,
    points: [
        {
            _class: 'curvePoint',
            cornerRadius: 0,
            curveFrom: '{0, 0}',
            curveMode: FileFormat.CurveMode.Straight,
            curveTo: '{0, 0}',
            hasCurveFrom: false,
            hasCurveTo: false,
            point: '{0, 0.5}',
        },
        {
            _class: 'curvePoint',
            cornerRadius: 0,
            curveFrom: '{0, 0}',
            curveMode: FileFormat.CurveMode.Straight,
            curveTo: '{0, 0}',
            hasCurveFrom: false,
            hasCurveTo: false,
            point: '{1, 0.5}',
        },
    ],
}); };
export var makeVerticalPath = function () { return ({
    isClosed: false,
    points: [
        {
            _class: 'curvePoint',
            cornerRadius: 0,
            curveFrom: '{0, 0}',
            curveMode: FileFormat.CurveMode.Straight,
            curveTo: '{0, 0}',
            hasCurveFrom: false,
            hasCurveTo: false,
            point: '{0.5, 0}',
        },
        {
            _class: 'curvePoint',
            cornerRadius: 0,
            curveFrom: '{0, 0}',
            curveMode: FileFormat.CurveMode.Straight,
            curveTo: '{0, 0}',
            hasCurveFrom: false,
            hasCurveTo: false,
            point: '{0.5, 1}',
        },
    ],
}); };
export var makeRectPath = function (radii) {
    if (radii === void 0) { radii = [0, 0, 0, 0]; }
    var r0 = radii[0], r1 = radii[1], r2 = radii[2], r3 = radii[3];
    return {
        isClosed: true,
        points: [
            {
                _class: 'curvePoint',
                cornerRadius: r0 || 0,
                curveFrom: '{0, 0}',
                curveMode: FileFormat.CurveMode.Straight,
                curveTo: '{0, 0}',
                hasCurveFrom: false,
                hasCurveTo: false,
                point: '{0, 0}',
            },
            {
                _class: 'curvePoint',
                cornerRadius: r1 || 0,
                curveFrom: '{1, 0}',
                curveMode: FileFormat.CurveMode.Straight,
                curveTo: '{1, 0}',
                hasCurveFrom: false,
                hasCurveTo: false,
                point: '{1, 0}',
            },
            {
                _class: 'curvePoint',
                cornerRadius: r2 || 0,
                curveFrom: '{1, 1}',
                curveMode: FileFormat.CurveMode.Straight,
                curveTo: '{1, 1}',
                hasCurveFrom: false,
                hasCurveTo: false,
                point: '{1, 1}',
            },
            {
                _class: 'curvePoint',
                cornerRadius: r3 || 0,
                curveFrom: '{0, 1}',
                curveMode: FileFormat.CurveMode.Straight,
                curveTo: '{0, 1}',
                hasCurveFrom: false,
                hasCurveTo: false,
                point: '{0, 1}',
            },
        ],
    };
};
export var makeShapePath = function (frame, path, resizingConstraint) { return (__assign(__assign({ _class: 'shapePath', frame: frame, do_objectID: generateID(), isFlippedHorizontal: false, isFlippedVertical: false, isLocked: false, isVisible: true, layerListExpandedType: FileFormat.LayerListExpanded.Undecided, name: 'Path', nameIsFixed: false, resizingConstraint: makeResizeConstraint(resizingConstraint), resizingType: FileFormat.ResizeType.Stretch, rotation: 0, shouldBreakMaskChain: false, booleanOperation: FileFormat.BooleanOperation.NA, edited: false }, path), { isFixedToViewport: false, pointRadiusBehaviour: FileFormat.PointsRadiusBehaviour.Rounded, exportOptions: {
        _class: 'exportOptions',
        exportFormats: [],
        includedLayerIds: [],
        layerOptions: 0,
        shouldTrim: false,
    } })); };
export var makeRectShapeLayer = function (x, y, width, height, radii, resizingConstraint) {
    if (radii === void 0) { radii = [0, 0, 0, 0]; }
    var fixedRadius = radii[0] || 0;
    var path = makeRectPath(radii);
    return __assign(__assign({}, path), { _class: 'rectangle', do_objectID: generateID(), frame: makeRect(x, y, width, height), isFlippedHorizontal: false, isFlippedVertical: false, isLocked: false, isVisible: true, layerListExpandedType: FileFormat.LayerListExpanded.Undecided, name: 'Path', nameIsFixed: false, resizingConstraint: makeResizeConstraint(resizingConstraint), resizingType: FileFormat.ResizeType.Stretch, rotation: 0, shouldBreakMaskChain: false, booleanOperation: FileFormat.BooleanOperation.NA, edited: false, fixedRadius: fixedRadius, hasConvertedToNewRoundCorners: true, isFixedToViewport: false, pointRadiusBehaviour: FileFormat.PointsRadiusBehaviour.Rounded, exportOptions: {
            _class: 'exportOptions',
            exportFormats: [],
            includedLayerIds: [],
            layerOptions: 0,
            shouldTrim: false,
        } });
};
export var makeShapeGroup = function (frame, layers, style, shadows, fills, resizingConstraint) {
    if (layers === void 0) { layers = []; }
    return ({
        _class: 'shapeGroup',
        do_objectID: generateID(),
        frame: frame,
        isLocked: false,
        isVisible: true,
        name: 'ShapeGroup',
        nameIsFixed: false,
        resizingConstraint: makeResizeConstraint(resizingConstraint),
        resizingType: FileFormat.ResizeType.Stretch,
        rotation: 0,
        shouldBreakMaskChain: false,
        style: makeStyle(style, fills, shadows),
        hasClickThrough: false,
        layers: layers,
        clippingMaskMode: 0,
        hasClippingMask: false,
        windingRule: FileFormat.WindingRule.EvenOdd,
        isFixedToViewport: false,
        exportOptions: {
            _class: 'exportOptions',
            exportFormats: [],
            includedLayerIds: [],
            layerOptions: 0,
            shouldTrim: false,
        },
        isFlippedHorizontal: false,
        isFlippedVertical: false,
        booleanOperation: FileFormat.BooleanOperation.NA,
        layerListExpandedType: FileFormat.LayerListExpanded.Undecided,
    });
};
export var makeVerticalBorder = function (x, y, length, thickness, color) {
    var frame = makeRect(x, y, thickness, length);
    var shapeFrame = makeRect(0, 0, thickness, length);
    var shapePath = makeShapePath(shapeFrame, makeVerticalPath());
    var content = makeShapeGroup(frame, [shapePath]);
    if (!content.style) {
        return content;
    }
    content.style.borders = [
        {
            _class: 'border',
            isEnabled: true,
            color: makeColorFromCSS(color),
            fillType: FileFormat.FillType.Color,
            position: FileFormat.BorderPosition.Center,
            thickness: thickness,
            contextSettings: {
                _class: 'graphicsContextSettings',
                blendMode: FileFormat.BlendMode.Normal,
                opacity: 1,
            },
            gradient: emptyGradient,
        },
    ];
    return content;
};
export var makeHorizontalBorder = function (x, y, length, thickness, color) {
    var frame = makeRect(x, y, length, thickness);
    var shapeFrame = makeRect(0, 0, length, thickness);
    var shapePath = makeShapePath(shapeFrame, makeHorizontalPath());
    var content = makeShapeGroup(frame, [shapePath]);
    if (!content.style) {
        return content;
    }
    content.style.borders = [
        {
            _class: 'border',
            isEnabled: true,
            color: makeColorFromCSS(color),
            fillType: FileFormat.FillType.Color,
            position: FileFormat.BorderPosition.Center,
            thickness: thickness,
            contextSettings: {
                _class: 'graphicsContextSettings',
                blendMode: FileFormat.BlendMode.Normal,
                opacity: 1,
            },
            gradient: emptyGradient,
        },
    ];
    return content;
};
