import { isNativeDocument } from './utils/isNativeDocument';
import { isNativeSymbolsPage } from './utils/isNativeSymbolsPage';
export var resetLayer = function (container) {
    if (isNativeDocument(container)) {
        resetDocument(container);
        return;
    }
    var layers = container.children();
    // Skip last child since it is the container itself
    for (var l = 0; l < layers.length - 1; l += 1) {
        var layer = layers[l];
        layer.removeFromParent();
    }
};
// Clear out all document pages and layers
export var resetDocument = function (documentData) {
    // Get Pages and delete them all (Except Symbols Page)
    var pages = documentData.pages();
    for (var index = pages.length - 1; index >= 0; index -= 1) {
        var page = pages[index];
        // Don't delete symbols page
        if (!isNativeSymbolsPage(page)) {
            if (pages.length > 1) {
                documentData.removePageAtIndex(index);
            }
            else {
                resetLayer(page);
            }
        }
    }
};
