export var getDocumentDataFromContext = function (ctx) {
    return (ctx.document ||
        (ctx.actionContext || {}).document ||
        NSDocumentController.sharedDocumentController().currentDocument()).documentData();
};
export var getDocumentDataFromContainer = function (container) {
    if (!container) {
        return getDocumentDataFromContext(context);
    }
    return container.documentData();
};
export var getDocument = function (document) {
    var documentData = getDocumentData(document);
    if (typeof documentData === 'undefined' || !('delegate' in documentData)) {
        return documentData;
    }
    return documentData.delegate();
};
export var getDocumentData = function (document) {
    var nativeDocument;
    var nativeDocumentData;
    if (!document && typeof context !== 'undefined') {
        nativeDocument = getDocumentDataFromContext(context);
    }
    else if (typeof document !== 'undefined' && 'sketchObject' in document) {
        nativeDocument = document.sketchObject;
    }
    else {
        nativeDocument = document;
    }
    if (!nativeDocument) {
        return undefined;
    }
    if ('documentData' in nativeDocument) {
        nativeDocumentData = nativeDocument.documentData();
    }
    else {
        nativeDocumentData = nativeDocument;
    }
    return nativeDocumentData;
};
