"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArtboardRenderer = void 0;
const sketch_file_format_ts_1 = require("@sketch-hq/sketch-file-format-ts");
const models_1 = require("../jsonUtils/models");
const resizeConstraint_1 = require("../jsonUtils/resizeConstraint");
const SketchRenderer_1 = require("./SketchRenderer");
class ArtboardRenderer extends SketchRenderer_1.SketchRenderer {
    renderGroupLayer({ layout, style, props }) {
        let color;
        if (style.backgroundColor !== undefined) {
            color = models_1.makeColorFromCSS(style.backgroundColor);
        }
        return Object.assign(Object.assign({ _class: 'artboard', do_objectID: models_1.generateID(`artboard:${props.name}`, !!props.name), frame: models_1.makeRect(layout.left, layout.top, layout.width, layout.height), name: props.name || 'Artboard', nameIsFixed: props.name !== undefined, isVisible: true, backgroundColor: color || models_1.makeColorFromCSS('white'), hasBackgroundColor: color !== undefined, isFlowHome: !!props.isHome }, (props.viewport && {
            presetDictionary: {
                allowResizedMatching: 0,
                offersLandscapeVariant: 1,
                name: props.viewport.name,
                width: props.viewport.width,
                height: props.viewport.height,
            },
        })), { isFlippedHorizontal: false, isFlippedVertical: false, isFixedToViewport: false, isLocked: false, booleanOperation: sketch_file_format_ts_1.FileFormat1.BooleanOperation.NA, exportOptions: {
                _class: 'exportOptions',
                exportFormats: [],
                includedLayerIds: [],
                layerOptions: 0,
                shouldTrim: false,
            }, layerListExpandedType: sketch_file_format_ts_1.FileFormat1.LayerListExpanded.Undecided, resizingType: sketch_file_format_ts_1.FileFormat1.ResizeType.Stretch, shouldBreakMaskChain: false, hasClickThrough: false, layers: [], includeInCloudUpload: true, includeBackgroundColorInExport: color !== undefined, horizontalRulerData: {
                _class: 'rulerData',
                base: 0,
                guides: [],
            }, verticalRulerData: {
                _class: 'rulerData',
                base: 0,
                guides: [],
            }, resizingConstraint: resizeConstraint_1.makeResizeConstraint(), resizesContent: false, rotation: 0 });
    }
}
exports.ArtboardRenderer = ArtboardRenderer;
