"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextRenderer = void 0;
const SketchRenderer_1 = require("./SketchRenderer");
const textLayers_1 = require("../jsonUtils/textLayers");
const models_1 = require("../jsonUtils/models");
const TextStyles_1 = require("../sharedStyles/TextStyles");
class TextRenderer extends SketchRenderer_1.SketchRenderer {
    getDefaultGroupName(props) {
        return props.name || 'Text';
    }
    renderBackingLayers({ layout, style, textStyle, props }) {
        // Append all text nodes's content into one string if name is missing
        const resolvedName = props.name
            ? props.name
            : props.textNodes.map((textNode) => textNode.content).join('');
        const frame = models_1.makeRect(0, 0, layout.width, layout.height);
        const layer = textLayers_1.makeTextLayer(this.platformBridge)(frame, resolvedName, props.textNodes, style, props.resizingConstraint, props.shadows);
        const resolvedTextStyle = TextStyles_1.TextStyles(() => this.platformBridge).resolve(textStyle);
        if (resolvedTextStyle) {
            if (!layer.style) {
                layer.style = resolvedTextStyle.sketchStyle;
            }
            layer.sharedStyleID = resolvedTextStyle.sharedObjectID;
        }
        return [layer];
    }
}
exports.TextRenderer = TextRenderer;
