import { FileFormat1 as FileFormat } from '@sketch-hq/sketch-file-format-ts';
import { SketchDocumentData, SketchDocument, WrappedSketchDocument, TextStyle, PlatformBridge } from '../types';
declare type RegisteredStyle = {
    cssStyle: TextStyle;
    name: string;
    sketchStyle: FileFormat.Style;
    sharedObjectID: FileFormat.Uuid;
};
declare type StyleHash = {
    [key: string]: RegisteredStyle;
};
declare type Options = {
    clearExistingStyles?: boolean;
    document?: SketchDocumentData | SketchDocument | WrappedSketchDocument;
};
export declare const TextStyles: (getDefaultBridge: () => PlatformBridge) => {
    registerStyle(name: string, style: TextStyle, platformBridge?: PlatformBridge): void;
    create(styles: {
        [key: string]: TextStyle;
    }, options?: Options, platformBridge?: PlatformBridge): StyleHash;
    resolve(style?: TextStyle | undefined): RegisteredStyle | undefined;
    get(name: string, document?: SketchDocument | SketchDocumentData | WrappedSketchDocument | undefined): TextStyle | undefined;
    clear(): void;
    toJSON(): FileFormat.SharedStyle[];
    styles(): StyleHash;
};
export {};
