"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDocumentData = exports.getDocument = exports.getDocumentDataFromContainer = exports.getDocumentDataFromContext = void 0;
exports.getDocumentDataFromContext = (ctx) => (ctx.document ||
    (ctx.actionContext || {}).document ||
    NSDocumentController.sharedDocumentController().currentDocument()).documentData();
exports.getDocumentDataFromContainer = (container) => {
    if (!container) {
        return exports.getDocumentDataFromContext(context);
    }
    return container.documentData();
};
exports.getDocument = (document) => {
    const documentData = exports.getDocumentData(document);
    if (typeof documentData === 'undefined' || !('delegate' in documentData)) {
        return documentData;
    }
    return documentData.delegate();
};
exports.getDocumentData = (document) => {
    let nativeDocument;
    let nativeDocumentData;
    if (!document && typeof context !== 'undefined') {
        nativeDocument = exports.getDocumentDataFromContext(context);
    }
    else if (typeof document !== 'undefined' && 'sketchObject' in document) {
        nativeDocument = document.sketchObject;
    }
    else {
        nativeDocument = document;
    }
    if (!nativeDocument) {
        return undefined;
    }
    if ('documentData' in nativeDocument) {
        nativeDocumentData = nativeDocument.documentData();
    }
    else {
        nativeDocumentData = nativeDocument;
    }
    return nativeDocumentData;
};
